# demo_1: Account class 
class Account:

	interest = 0.02 # class attribute

	def __init__(self, account_holder):
		self.holder = account_holder
		self.balance = 0

	def deposit(self, amount):
		self.balance += amount
		return self.balance

	def withdraw(self, amount):
		if self.balance < amount:
			return 'insufficient funds'
		self.balance -= amount;
		return self.balance

# demo_2: Checking Account class
class CheckingAccount(Account):
	interest = 0.01
	withdraw_fee = 1
	def withdraw(self, amount):
		return Account.withdraw(self, amount + self.withdraw_fee)
		# return super().withdraw(amount + self.withdraw_fee)

# demo_3: Bank
class Bank:
	"""A bank has accounts and pays interest.
	>>> bank = Bank()
	>>> yue = bank.open_account('yue',100)
	>>> tian = bank.open_account('tian',10,CheckingAccount)
	>>> yue.interest
	0.02
	>>> tian.interest
	0.01
	>>> bank.pay_interest()
	>>> yue.balance
	102.0
	>>> tian.balance
	10.1
	"""
	def __init__(self):
		self.accounts = []

	def open_account(self, holder, amount, account_type = Account):
		account = account_type(holder)
		account.deposit(amount)
		self.accounts.append(account)
		return account

	def pay_interest(self):
		for account in self.accounts:
			account.deposit(account.balance * account.interest)

